// crc16.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
using namespace std;

inline unsigned char hexStrToNibble(char c) {
	switch (c) {
		case '0': return 0;
		case '1': return 1;
		case '2': return 2;
		case '3': return 3;
		case '4': return 4;
		case '5': return 5;
		case '6': return 6;
		case '7': return 7;
		case '8': return 8;
		case '9': return 9;
		case 'a': case 'A': return 10;
		case 'b': case 'B': return 11;
		case 'c': case 'C': return 12;
		case 'd': case 'D': return 13;
		case 'e': case 'E': return 14;
		case 'f': case 'F': return 15;
		default: exit(1);
	}
}

inline unsigned char readByte(char* b) {
	return ((hexStrToNibble(*b) << 4) + hexStrToNibble(*(b+1)));
}

inline char nibbleToHex(unsigned short n) {
	static char cv[17] = "0123456789ABCDEF";
	return cv[n & 0xF];
}

char* shortToHexStr(unsigned short s) {
	static char hex[5] = "xxxx";	
	hex[0] = nibbleToHex(s >> 12);
	hex[1] = nibbleToHex(s >> 8);
	hex[2] = nibbleToHex(s >> 4);
	hex[3] = nibbleToHex(s);
	return hex;
}


int main(int argc, char* argv[])
{
	char buffer[1024];
	char* in = buffer;
	while (1) {
		cout << "Enter the string of bytes in Hexa form (x to exit)\n";
		in = buffer;
		cin >> in;
		if (*in == 'x') return 0;
		unsigned short crc = 0xFFFF;
		unsigned short b;
		do {
			b = readByte(in++); 
			for (int i = 0 ; i < 8 ; i++) 
				crc = (crc << 1) ^ ((((crc >> 8) ^ (b << i)) & 0x0080) ? 0x1021 : 0);
		} while (*(++in) != 0);
		cout << "The crc is => " << shortToHexStr(crc) << "\n";

	}
	return 0;
}
